
 clear all;clc

%%% PERFORMS LOSS MINIMIZATION


%global beta sigma gamma eta an_vec alpha_vec lambda_vec theta_vec N
%global beta sigma gamma eta zetaZAlpha SIGMA_SS an_vec alpha_vec lambda_vec theta_vec dimK NF N G sel W_mat
global beta sigma gamma eta zetaZAlpha SIGMA_SS an_vec alpha_vec lambda_vec theta_vec dimK NF N G sel rho_cts%D W_mat F

%global A B C
%% Model parameters


%% Preferences and technologies

 beta = .997; % discount rate  
 gamma = 1;  % elasticity of substitution inter sector
 theta = 5; % elasticity of substitution intra sector
 eta = 0.5;  % elasticity of marginal cost w.r.t. output/consumption
 sigma = 1;  % elastasticity of substitution for consumption           
 lambda = 1/0.88; %% curvature in production function          
  alpha = 1-0.103; %% homog. Calvo param
 
 
 %% OPTIONS 
 
 sel = 2;    
 
 %% set sel ==
 %% 1. core-noncore
 %% 2. multisector
 
%% CORE-NONCORE

  N = 15; % Number of sectors


%% Sector shares
  
  an_vec = [0.056
0.045
0.024
0.085
0.052
0.042
0.027
0.079
0.151
0.035
0.022
0.041
0.162
0.040
0.138
];%./100;
% Re-normalize an_vec

an_vec = an_vec./sum(an_vec);


alpha_vec = alpha.*ones(N,1);
 

           
theta_vec = theta*ones(N,1);
 
lambda_vec  = 1./[0.90
0.88
0.87
0.84
0.88
0.87
0.77
0.86
0.88
0.90
0.64
0.89
1.00
0.96
0.96
];

    

 %% common shock

  sigma_cs = 0; %std of common shock

  rho_cts = 0;


   

 %% sector specific shocks
 
 rho_ss = -0.046;  %% autoregressive coefficient
                %% NOTE: we assume that every sector has the same rho
 
 zetaZAlpha = rho_ss.*ones(N,1);   %% vector of autoregressive coefficients
 
 
             
 sigma_ss = 120.37/100;   %% std sector-specific shocks 
                   %% NOTE: we assume that every sector has the same sigma



               
 SIGMA_SS = diag([(sigma_ss.*sigma_ss).*ones(N,1);sigma_cs^2]);
  
 


%% Uploading weights and shock calibration

   %% Pce: this case is not really interesting. it is rather the benchmark
   %% to measure improvements
 
 %% CONDI weights
 
  opt_weights = [0.0556
    0.0466
    0.0254
    0.0959
    0.0539
    0.0444
    0.0354
    0.0854
    0.1564
    0.0348
    0.0388
    0.0416
    0.1301
    0.0350
    0.1207
 ];%./100;

%% Computing loss
 


%% optimal weights rearranged...

ini_weights = opt_weights; 

ini_weights_cpi = an_vec;







%% core only

ini_weights_core_raw = an_vec;

ini_weights_core_raw(4:5) = zeros(2,1);
ini_weights_core_raw(7) = 0;
ini_weights_core_raw(11) = 0;  

%ini_weights_core_raw = ini_weights_core_raw+0.0001*(ones(15,1));

sum_weighs = sum(ini_weights_core_raw);
ini_weights_core = ini_weights_core_raw./sum_weighs;


%% core+food away from home

ini_weights_core1_raw = an_vec;

ini_weights_core1_raw(4) = 0;
ini_weights_core1_raw(7) = 0;
ini_weights_core1_raw(11) = 0;    

sum_weighs1 = sum(ini_weights_core1_raw);
ini_weights_core_c1 = ini_weights_core1_raw./sum_weighs1;
    
%% core+food away-autos-clothing

ini_weights_core2_raw = an_vec;

ini_weights_core2_raw(1) = 0;
ini_weights_core2_raw(4) = 0;
ini_weights_core2_raw(6) = 0;
ini_weights_core2_raw(7) = 0;
ini_weights_core2_raw(11) = 0;


sum_weighs2 = sum(ini_weights_core2_raw);
ini_weights_core_c2 = ini_weights_core2_raw./sum_weighs2;


%% Vasco transformation to obtain positive weights (we normalize second
%% sector so that the sector with higher weight is 1)


ini_weights_vasco1 = log(ini_weights(1:N)./ini_weights(9));
ini_weights_vasco = [ini_weights_vasco1(1:8);ini_weights_vasco1(10:end)];

ini_weights_vasco_cpi1 = log(ini_weights_cpi(1:N)./ini_weights_cpi(9));
ini_weights_vasco_cpi = [ini_weights_vasco_cpi1(1:8);ini_weights_vasco_cpi1(10:end)];

ini_weights_vasco_core1 = log(ini_weights_core(1:N)./ini_weights_core(9));
ini_weights_vasco_core = [ini_weights_vasco_core1(1:8);ini_weights_vasco_core1(10:end)];

ini_weights_vasco_core_c11 = log(ini_weights_core_c1(1:N)./ini_weights_core_c1(9));
ini_weights_vasco_core_c1 = [ini_weights_vasco_core_c11(1:8);ini_weights_vasco_core_c11(10:end)];

ini_weights_vasco_core_c21 = log(ini_weights_core_c2(1:N)./ini_weights_core_c2(9));
ini_weights_vasco_core_c2 = [ini_weights_vasco_core_c21(1:8);ini_weights_vasco_core_c21(10:end)];


  

 %% Loss under optimal policy

Loss_opt = Loss_fun_opt(ini_weights_vasco);


 %% Loss under suboptimal policy

Loss_sub_opt = Loss_fun_cs(ini_weights_vasco);


%% Loss under cpi

Loss_sub_cpi = Loss_fun_cs(ini_weights_vasco_cpi);

%% Loss under core

Loss_sub_core = Loss_fun_cs(ini_weights_vasco_core);



%% Loss under core+food away from home

Loss_sub_c1 = Loss_fun_cs(ini_weights_vasco_core_c1);

%% Loss under core+food away-autos-clothing

Loss_sub_c2 = Loss_fun_cs(ini_weights_vasco_core_c2);


%% Compupting inflation equivalent

eta_vec = lambda_vec.*(1+eta)-1; %% convolution of parameters...

den_vec = 1.+(theta_vec.*eta_vec); %% this is  the vector 1+theta(n)*eta in the
                               %% Phillips curve. It expresses the common
                               %% denominator of the variables'
                               %% coefficients

el_mc_vec = ((1-alpha_vec.*beta).*(1-alpha_vec))...
      ./alpha_vec; %% defines vector of the elasticity of inflation to the
                    %%% mc in each sector

pi_eq = 12*sqrt(((1-beta)./(an_vec'*(theta_vec.*den_vec./el_mc_vec))))*sqrt(Loss_sub_opt-Loss_opt);

pi_eq_cpi = 12*sqrt(((1-beta)./(an_vec'*(theta_vec.*den_vec./el_mc_vec))))*sqrt(Loss_sub_cpi-Loss_opt);

pi_eq_core = 12*sqrt(((1-beta)./(an_vec'*(theta_vec.*den_vec./el_mc_vec))))*sqrt(Loss_sub_core-Loss_opt);

pi_eq_c1 = 12*sqrt(((1-beta)./(an_vec'*(theta_vec.*den_vec./el_mc_vec))))*sqrt(Loss_sub_c1-Loss_opt);
    
pi_eq_c2 = 12*sqrt(((1-beta)./(an_vec'*(theta_vec.*den_vec./el_mc_vec))))*sqrt(Loss_sub_c2-Loss_opt);



