
 clear all;clc

%%% PERFORMS LOSS MINIMIZATION


%global beta sigma gamma eta an_vec alpha_vec lambda_vec theta_vec N
%global beta sigma gamma eta zetaZAlpha SIGMA_SS an_vec alpha_vec lambda_vec theta_vec dimK NF N G sel W_mat
global beta sigma gamma eta zetaZAlpha SIGMA_SS an_vec alpha_vec lambda_vec theta_vec dimK NF N G sel rho_cts%D W_mat F

%global A B C
%% Model parameters


%% Preferences and technologies

 beta = .997; % discount rate  
 gamma = 1;  % elasticity of substitution inter sector
 theta = 5; % elasticity of substitution intra sector
 eta = 0.5;  % elasticity of marginal cost w.r.t. output/consumption
 sigma = 1;  % elastasticity of substitution for consumption           
 lambda = 1/0.88; %% curvature in production function          
  alpha = 1-0.103; %% homog. Calvo param
 
 
 %% OPTIONS 
 
 sel = 1;    
 
 %% set sel ==
 %% 1. core-noncore
 %% 2. multisector
 
%% CORE-NONCORE

  N = 2; % Number of sectors


%% Sector shares
  
  an_vec = [81.4%
18.6%
]./100;

% Re-normalize an_vec
an_vec = an_vec./sum(an_vec);


alpha_vec = alpha.*ones(N,1);
 

           
theta_vec = [5.8
4.0
 ];

 

lambda_vec  = lambda*ones(N,1);
    

 %% common shock

  sigma_cs = 0; %std of common shock

  rho_cts = 0;


   

 %% sector specific shocks
 
 rho_ss =  -0.0305;  %% autoregressive coefficient
                %% NOTE: we assume that every sector has the same rho
 
 zetaZAlpha = rho_ss.*ones(N,1);   %% vector of autoregressive coefficients
 
 
             
 sigma_ss = 51.8772/100;   %% std sector-specific shocks 
                   %% NOTE: we assume that every sector has the same sigma



               
 SIGMA_SS = diag([(sigma_ss.*sigma_ss).*ones(N,1);sigma_cs^2]);
  
 


%% Uploading weights and shock calibration

   %% Pce: this case is not really interesting. it is rather the benchmark
   %% to measure improvements
 
 %% CONDI weights
 
  opt_weights = [85.4%
14.6
]./100;

%% Computing loss
 %% optimal weights rearranged...

ini_weights = opt_weights; 

ini_weights_cpi = an_vec;







ini_weights_vasco_core = 1;     
    
ini_weights_vasco = ini_weights(1);

ini_weights_vasco_cpi = ini_weights_cpi(1);

  

 %% Loss under optimal policy

Loss_opt = Loss_fun_opt(ini_weights_vasco);


 %% Loss under suboptimal policy

Loss_sub_opt = Loss_fun_cs(ini_weights_vasco);


%% Loss under cpi

 Loss_sub_cpi = Loss_fun_cs(ini_weights_vasco_cpi);

%% Loss under core

 Loss_sub_core = Loss_fun_cs(ini_weights_vasco_core);


%% Compupting inflation equivalent

eta_vec = lambda_vec.*(1+eta)-1; %% convolution of parameters...

den_vec = 1.+(theta_vec.*eta_vec); %% this is  the vector 1+theta(n)*eta in the
                               %% Phillips curve. It expresses the common
                               %% denominator of the variables'
                               %% coefficients

el_mc_vec = ((1-alpha_vec.*beta).*(1-alpha_vec))...
      ./alpha_vec; %% defines vector of the elasticity of inflation to the
                    %%% mc in each sector

pi_eq = 12*sqrt(((1-beta)./(an_vec'*(theta_vec.*den_vec./el_mc_vec))))*sqrt(Loss_sub_opt-Loss_opt);

pi_eq_cpi = 12*sqrt(((1-beta)./(an_vec'*(theta_vec.*den_vec./el_mc_vec))))*sqrt(Loss_sub_cpi-Loss_opt);

pi_eq_core = 12*sqrt(((1-beta)./(an_vec'*(theta_vec.*den_vec./el_mc_vec))))*sqrt(Loss_sub_core-Loss_opt);




