




function  Loss = Loss_fun_calibration(x)


global beta sigma gamma eta an_vec alpha_vec lambda_vec theta_vec...
       N stdNS_infl rhoNS_infl std_infl rho_infl rho_c sigma_c %A B C





%% Constructs matrces for REds, solds 


%% Parameters

rho_ss_vec = x(1)*ones(N,1); %% autocorr. of sect. spec. shocks


sigma_ss_vec = x(2)*ones(N,1);  %% std sector-specific shocks 
                          
sigma_cs = 0;              %% std of common shock


rho_cts = 0;         %% autocorr. of common shock
 
zetaZAlpha = rho_ss_vec;   %% vector of autoregressive coefficients






opt_weights = ones(N+1,1); %% this is not used!
               
SIGMA_SS = diag([sigma_ss_vec.^2;sigma_c^2;sigma_cs^2]);


amax =  max([rho_ss_vec;rho_cts]); %% unit root detector
amin = min([rho_ss_vec;rho_cts]); 


 
[A, B, C, kAlphaR, kAlphaC, kAlphaZ, dimK] =...
    param_natural_target7_cs(N, sigma,  beta, gamma, theta_vec, eta,...
    alpha_vec, lambda_vec, zetaZAlpha, opt_weights,an_vec,rho_c,rho_cts);


% disp('ABC done')


      
%% Solves REE for given weights
  [Br,Cr,Lr,NF,er_s] = redsf(A,B,C,size(A,1),size(C,2),dimK);
  
  
  
  if er_s == 0   %% makes sure there are no errors
      
   [D,F,G,H,er_d] = soldsf(Br,Cr,Lr,size(A,1),size(C,2),dimK, NF);

  
  else er_d = 1;
   
      
  end
  
  
   
    
   if er_d == 0 && amax < 0.95 && amin > -0.95
 
   
      
    
      D = real(D); F = real(F); G = real(G); H = real(H);

      
%   disp('REDS solds done')
  
  %% Computes the Loss


%% Compute first variance-covariance of the state vector


% disp('sk')
SIGMAK = vcv(SIGMA_SS, G, H);
% disp('end sk')


SIGMAY = D*SIGMAK*D'+F*SIGMA_SS*F'; %% transforms the weights matrix


%% Calibrating parameters with inflation moments
 %% List: total inflation = 2,2
 %%       total inflation lag = 3*N-1+jump_agg+3       
 %%       sect. inflation = jump_agg+1:N+jump_agg
 %%       sect. inflation lag = 3*N-1+jump_agg+4:4*N-1+jump_agg+4
 
jump_agg = 6;

infln = 2;
infllagn = 3*N-1+jump_agg+3;




loss_vec = [SIGMAY(infln,infln)-std_infl^2
            SIGMAY(infln,infllagn)/SIGMAY(infln,infln)-rho_infl
            ];


Loss = loss_vec'*eye(2)*loss_vec;%*1000; 


  else
      
      Loss = 10000000000000000000000000000000000000000;


  end %% closes er_s loop
  
  
      


