clear all;clc

%%% PERFORMS LOSS MINIMIZATION


global beta sigma gamma eta an_vec alpha_vec lambda_vec theta_vec...
       N stdNS_infl rhoNS_infl std_infl rho_infl rho_c sigma_c epsZ%A B C


%global A B C




%% Model parameters


%% Preferences and technologies

 beta = .997; % discount rate  
 gamma = 1;  % elasticity of substitution inter sector
 theta = 5; % elasticity of substitution intra sector
 eta = 0.5;  % elasticity of marginal cost w.r.t. output/consumption
 sigma = 1;  % elasticity of substitution for consumption           
 lambda = 1/0.88; %% curvature in production function          
 alpha = 1-0.103; %% homog. Calvo param
 
 
%% CORE-NONCORE (GOODS AND SERVICES SPLIT)

  N = 2; % Number of sectors

%% Sector shares

  
 an_vec = [81.4%
18.6%
]./100;

% Re-normalize an_vec

an_vec = an_vec./sum(an_vec);

 
 alpha_vec = [9.6%
12.7]./100;  

 alpha_vec = 1-alpha_vec; 
           
 theta_vec = [5.8
4.0
 ];


lambda_vec  = lambda*ones(N,1);
    

    



std_infl = 0.19;%;/100; %% standard deviation of inflation

rho_infl = 0.17; %% autocorr. of inflation

rho_c = 0; %% autocorr. nominal income  

sigma_c = 0.51;%/100; %% standard deviation nominal income

 

  
 
 
diary('results')
  
 
 
 %% Loss minimization
 
 for j = 1:1  %% set >> 1 if want to check different initial conditions
    
     
  %% Unconstrained optimization
 
  
  x0 = [0.04;0.7];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% LOSS Minimization

size_vector = 1e-2.*ones(length(x0),1);


 GMat = diag(size_vector);

 
 % FMINSEARCH
 
 stop_crit_x = 1e-6; stop_crit_f = 1e-7; maxits = 1000; 

 max_funevals = 10*maxits;

 options = optimset('Display','iter','TolX',stop_crit_x,'TolFun',stop_crit_f,'MaxFunEvals',max_funevals,'MaxIter',maxits);
%,'Hessian','on');

for j = 1:3

    
 [opt_x,fval,exitflag,output] = fminsearch('Loss_fun_calibration',x0,options);
   
 %x0 = opt_x; 
 
if exitflag == 1
    break
   
end

x1 = opt_x;

if j == 3
   
%    diary('results')
end

[fh,opt_x1,gh,H,itct,fcount,retcodeh] = csminwel('Loss_fun_calibration',x1,GMat,[],1e-7,100);


x0 = opt_x1;



end


  end 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


diary off



save results 
