
 clear all;clc

%%% PERFORMS LOSS MINIMIZATION


global beta sigma gamma eta zetaZAlpha SIGMA_SS an_vec alpha_vec lambda_vec theta_vec dimK NF N G sel rho_cts%D W_mat F

%global A B C
%% Model parameters


%% Preferences and technologies

 beta = .997; % discount rate  
 gamma = 1;  % elasticity of substitution inter sector
 theta = 5; % elasticity of substitution intra sector
 eta = 0.5;  % elasticity of marginal cost w.r.t. output/consumption
 sigma = 1;  % elastasticity of substitution for consumption           
 lambda = 1/0.88; %% curvature in production function          
  alpha = 1-0.103; %% homog. Calvo param

 
%% CORE-NONCORE 

  N = 2; % Number of sectors
  sel = 1;

%% Sector shares

  
  an_vec = [81.4%
18.6%
]./100;

% Re-normalize an_vec
an_vec = an_vec./sum(an_vec);

alpha_vec = [9.6%
12.7]./100;  

 alpha_vec = 1-alpha_vec; 
           
 theta_vec = [5.8
4.0
 ];


lambda_vec  = lambda*ones(N,1);
    

 %% common shock

  sigma_cs = 0; %std of common shock

  rho_cts = 0;


   
   

 
 
rho_ss = -0.0234;

zetaZAlpha = rho_ss.*ones(N,1);   %% vector of autoregressive coefficients
  %% NOTE: we assume that every sector has the same rho
 
             

 
 sigma_ss = 54.9768/100;  %% std sector-specific shocks 
                   %% NOTE: we assume that every sector has the same sigma


               
 SIGMA_SS = diag([(sigma_ss.*sigma_ss).*ones(N,1);sigma_cs^2]);
 
 
 %% Loss minimization
 
 for j = 1:1  %% set >> 1 if want to check different initial conditions
    
     
%% Initial condition: cpi targeting

 %  ini_weights = an_vec;

%% Random initial conditions  

%  rand_weights = abs(0.2*randn(N,1))+alpha_vec./sum(alpha_vec);
%  
%   ini_weights = rand_weights./sum(rand_weights);

%% Weight proportional to stickiness

  ini_weights = alpha_vec./sum(alpha_vec);

%% optimal weights in previous experiment...

%   ini_weights = [0.0001
% 0.04
% 0.03
% 0.02
% 0.03
% 0.02
% 0.0001
% 0.05
% 0.08
% 0.0001
% 0.21
% 0.01
% 0.02
% 0.10
% 0.0001
% 0.25
% 0.13
% ]; 


    
%% Vasco transformation to obtain positive weights (we normalize second
%% sector so that the sector with higher weight is 1)

    
if sel == 2

ini_weights_vasco1 = log(ini_weights(1:N)./ini_weights(5));
ini_weights_vasco = [ini_weights_vasco1(1:4);ini_weights_vasco1(6:end)];

else

ini_weights_vasco = ini_weights(1);


end


    %% only two sectors...
%ini_weights_vasco = ini_weights(1);

diary('results')
  
  %% Unconstrained optimization
 
% [fh,opt_weights,gh,H,itct,fcount,retcodeh] = csminwel('Loss_fun_cs',ini_weights_vasco,1e-3*eye(N-1),[],1e-10,10000)


x0 = ini_weights_vasco;

size_vector = 1e-3.*ones(length(x0),1);
GMat = diag(size_vector);

 

 
 
 stop_crit_x = 1e-6; stop_crit_f = 1e-7; maxits = 1000; 

 max_funevals = 10*maxits;

 options = optimset('Display','iter','TolX',stop_crit_x,'TolFun',stop_crit_f,'MaxFunEvals',max_funevals,'MaxIter',maxits);
%,'Hessian','on');

for j = 1:3

    
 [opt_x,fval,exitflag,output] = fminsearch('Loss_fun_cs',x0,options);
   
 %x0 = opt_x; 
 
if exitflag == 1
    opt_x1 = opt_x;
    break
   
end

x1 = opt_x;

if j == 3
   
%    diary('results')
end

[fh,opt_x1,gh,H,itct,fcount,retcodeh] = csminwel('Loss_fun_cs',x1,GMat,[],1e-7,100);


x0 = opt_x1;



end

opt_weights = opt_x1;




%% display optimal weights

if sel == 2
    
opt_weights_n = [exp(opt_weights(1:4));1; exp(opt_weights(5:end))];

opt_weights_n =(opt_weights_n./sum(opt_weights_n))

else
    
opt_weights_n = opt_weights;


end


end


diary off



save results 

