function gamma=sylvester(W,S,T,d)
%sylvester(W,S,T,d)
%solves the matrix equation M=W+SMT using the Doubeling Algorithm
%from Anderson,Hansen,McGrattan and Sargent
%we however add a discount factor 0<d<=1 : M=W+dSMT
alpha=S;
beta=T;
gamma=W;
delta=d;
test=1e-12;
count=0;
while (norm(gamma-W-d*S*gamma*T,inf)>test),
   gamma=gamma+delta*alpha*gamma*beta;
   delta=delta*delta;
   alpha=alpha*alpha;
   beta=beta*beta;
   
   
     count=count+1;
   
  %% checking convergence
  
   if count == 5000
       
       test=1e-10;
       
       disp('warning, no full convergence in Sylvester: test 1e-10')
   end
   
   
   if count == 25000
       
       test=1e-9;
       disp('warning, no full convergence in Sylvester: test 1e-9')
   end
   
   
   if count == 100000
       
       test=1e-2;
       disp('warning, no convergence in Sylvester!')
   end
   
 
   
   
   
end

%disp(['sylvester eq converged in ',num2str(count),' doubeling steps']);
return;


