




function  Loss = Loss_fun_calibration(x)


global beta sigma gamma eta an_vec alpha_vec lambda_vec theta_vec...
       N stdNS_infl rhoNS_infl std_infl rho_infl rho_c sigma_c epsZ%A B C



%% calibrate autocorrelation and std of income growth


%% Constructs matrces for REds, solds 


%% Parameters

rho_ss_vec = x(1:15); %% autocorr. of sect. spec. shocks


sigma_ss_vec = x(16:30);  %% std sector-specific shocks 
                          
sigma_cs = x(32);             %% std of common shock


rho_cts = x(31);        %% autocorr. of common shock
 
zetaZAlpha = rho_ss_vec;   %% vector of autoregressive coefficients



opt_weights = ones(N+1,1); %% this is not used!
               
SIGMA_SS_std = diag([sigma_ss_vec;sigma_c;sigma_cs]);

ss_vec = SIGMA_SS_std*epsZ;

amax =  max([rho_ss_vec;rho_cts]); %% unit root detector
amin = min([rho_ss_vec;rho_cts]); 

if amax < 0.95 && amin > -0.95
 
    
    
[A, B, C, kAlphaR, kAlphaC, kAlphaZ, dimK] =...
    param_natural_target7_cs(N, sigma,  beta, gamma, theta_vec, eta,...
    alpha_vec, lambda_vec, zetaZAlpha, opt_weights,an_vec,rho_c,rho_cts);


% disp('ABC done')


      
%% Solves REE for given weights
  [Br,Cr,Lr,NF,er_s] = redsf(A,B,C,size(A,1),size(C,2),dimK);
  
else
    
    er_s = 1;
    
end
  
  
  if er_s == 0   %% makes sure there are no errors
      
   [D,F,G,H,er_d] = soldsf(Br,Cr,Lr,size(A,1),size(C,2),dimK, NF);

  
  else er_d = 1;
   
      
  end
  
  
   
    
   if er_d == 0 
 
    
      
    
      D = real(D); F = real(F); G = real(G); H = real(H);

      
%   disp('REDS solds done')
  
%% Computes the Loss

K0 = zeros(dimK,1);

Y_simulated = sim(K0, ss_vec, D, F, G, H);




%% Calibrating parameters with inflation moments
 %% List: total inflation = 2,2
 %%       total inflation lag = 3*N-1+jump_agg+3       
 %%       sect. inflation = jump_agg+1:N+jump_agg
 %%       sect. inflation lag = 3*N-1+jump_agg+4:4*N-1+jump_agg+4
 
jump_agg = 6;

infln = 2;
infllagn = 3*N-1+jump_agg+3;
inflsectn = jump_agg+1:N+jump_agg;

corr_sect = zeros(15,1);

std_sect = zeros(15,1);

   for jj = 1:15
 
  corr_sect(jj) = corr(Y_simulated(jump_agg+jj,:)',Y_simulated(3*N-1+jump_agg+4+jj,:)');     
  
  std_sect(jj) = std(Y_simulated(jump_agg+jj,:)'); 
  
  
   end


loss_vec = [std(Y_simulated(infln,:)')-std_infl
            corr(Y_simulated(infln,:)',Y_simulated(infllagn,:)')-rho_infl            
            std_sect - stdNS_infl
            corr_sect-rhoNS_infl];


Loss = loss_vec'*eye(32)*loss_vec;%*1000; 


  else
      
      Loss = 10000000000000000000000000000000000000000;


  end %% closes er_s loop
  
  
      

