
 clear all;clc

%%% PERFORMS LOSS MINIMIZATION


global beta sigma gamma eta an_vec alpha_vec lambda_vec theta_vec...
       N stdNS_infl rhoNS_infl std_infl rho_infl rho_c sigma_c epsZ%A B C


%global A B C

%% Shocks
slength = 5000;
epsZ = randn(17,slength);


%% Model parameters


%% Preferences and technologies

 beta = .997; % discount rate  
 gamma = 1;  % elasticity of substitution inter sector
 theta = 5; % elasticity of substitution intra sector
 eta = 0.5;  % elasticity of marginal cost w.r.t. output/consumption
 sigma = 1;  % elasticity of substitution for consumption           
 lambda = 1/0.88; %% curvature in production function          
 alpha = 1-0.103; %% homog. Calvo param
 
 
%% CORE-NONCORE (GOODS AND SERVICES SPLIT)

  N = 15; % Number of sectors

%% Sector shares

 an_vec = [0.056
0.045
0.024
0.085
0.052
0.042
0.027
0.079
0.151
0.035
0.022
0.041
0.162
0.040
0.138
];%./100;

% Re-normalize an_vec

an_vec = an_vec./sum(an_vec);


 
alpha_vec = [0.366
0.092
0.109
0.130
0.056
0.322
0.876
0.104
0.103
0.114
0.385
0.156
0.083
0.100
0.075
];%./100; 

alpha_vec = 1-alpha_vec; 
           
theta_vec = [5.2
5.0
4.9
4.5
5.0
4.8
4.0
4.7
4.9
5.2
3.2
5.2
7.7
6.1
6.0
];
 
lambda_vec  = 1./[0.89
0.88
0.88
0.86
0.88
0.87
0.82
0.87
0.88
0.89
0.75
0.89
0.94
0.92
0.92
];    



stdNS_infl = [3.76
3.95
4.67
2.86
1.06
5.35
64.29
5.48
1.10
3.10
17.50
3.35
1.22
2.11
3.20
]./12; %% standard deviation of sect. inflation (% annualized)

rhoNS_infl = [0.18
-0.11
-0.13
-0.13
-0.07
-0.07
0.26
-0.35
0.34
-0.07
0.20
-0.05
0.22
0.14
0.13

]; %% autocorr. of sect inflation

std_infl = 0.19;%/100; %% standard deviation of inflation

rho_infl = 0.17; %% autocorr. of inflation

rho_c = 0; %% autocorr. nomonal income  

sigma_c = 0.51;%/100; %% standard deviation nominal income

 

  
 
 
diary('results')
  
 
 
 %% Loss minimization
 
 for j = 1:1  %% set >> 1 if want to check different initial conditions
    
     
  %% Unconstrained optimization
  %% LIST OF PARAMETERS: 15 rhos;15 sigma_ss;rho_cs;sigma_cs
  
  rhos_ini = rhoNS_infl;
  
  sigamas_ini = [0.0069
    0.0059
    0.0075
    0.0099
    0.0051
    0.0040
    0.0120
    0.0056
    0.0016
    0.0174
    0.0399
    0.0154
    0.0146
    0.0087
    0.0097]*100; %0.1/100*ones(15,1);%stdNS_infl;
  
 % x0 = [rhos_ini;sigamas_ini;0.54;1];
x0 =[

   -0.4746
   -0.9460
   -0.2248
   -0.3471
   -0.8401
    0.0447
    0.9456
   -0.3779
    0.6478
   -0.2347
    0.4359
   -0.5188
   -0.8181
   -0.7689
   -0.9394
    0.2386
  -17.1276
 -100.7201
   40.7194
   59.3195
   -0.9150
    8.6683
 -132.3858
    6.7357
   50.0305
  -13.9402
  -20.8783
   31.3039
  -26.5581
   22.2999
   -0.1450
    4.0974];


%% LOSS Minimization

size_vector = 1e-2.*ones(length(x0),1);
size_vector(5) = 1e-6;
size_vector(7) = 1e-6;
size_vector(9) = 1e-6;
size_vector(14:15) = 1e-6;

 GMat = diag(size_vector);

 
 % FMINSEARCH
 
 stop_crit_x = 1e-6; stop_crit_f = 1e-7; maxits = 5000; 

 max_funevals = 10*maxits;

 options = optimset('Display','iter','TolX',stop_crit_x,'TolFun',stop_crit_f,'MaxFunEvals',max_funevals,'MaxIter',maxits);
%,'Hessian','on');

for j = 1:3

    
 [opt_x,fval,exitflag,output] = fminsearch('Loss_fun_calibration',x0,options);
   
 %x0 = opt_x; 
 
if exitflag == 1
    break
   
end

x1 = opt_x;

if j == 3
   
%    diary('results')
end

[fh,opt_x1,gh,H,itct,fcount,retcodeh] = csminwel('Loss_fun_calibration',x1,GMat,[],1e-7,100);


x0 = opt_x1;



end


  end 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


diary off



save results 
