
 clear all;clc

%%% PERFORMS LOSS MINIMIZATION


global beta sigma gamma eta zetaZAlpha SIGMA_SS an_vec alpha_vec lambda_vec theta_vec dimK NF N G sel rho_cts%D W_mat F

%global A B C
%% Model parameters


%% Preferences and technologies

 beta = .997; % discount rate  
 gamma = 1;  % elasticity of substitution inter sector
 theta = 5; % elasticity of substitution intra sector
 eta = 0.5;  % elasticity of marginal cost w.r.t. output/consumption
 sigma = 1;  % elastasticity of substitution for consumption           
 lambda = 1/0.88; %% curvature in production function          
  alpha = 1-0.103; %% homog. Calvo param

 
%% CORE-NONCORE 

  N = 15; % Number of sectors
  sel = 2;

%% Sector shares

  
 an_vec = [0.056
0.045
0.024
0.085
0.052
0.042
0.027
0.079
0.151
0.035
0.022
0.041
0.162
0.040
0.138
];%./100;
% Re-normalize an_vec

an_vec = an_vec./sum(an_vec);

 
alpha_vec = [0.366
0.092
0.109
0.130
0.056
0.322
0.876
0.104
0.103
0.114
0.385
0.156
0.083
0.100
0.075
];%./100;  
alpha_vec = 1-alpha_vec; 
           
theta_vec = [5.2
5.0
4.9
4.5
5.0
4.8
4.0
4.7
4.9
5.2
3.2
5.2
7.7
6.1
6.0
];
 
lambda_vec  = 1./[0.89
0.88
0.88
0.86
0.88
0.87
0.82
0.87
0.88
0.89
0.75
0.89
0.94
0.92
0.92
];
    

 %% common shock

  sigma_cs = 2.3972; %std of common shock

  rho_cts = 0.3549;


   
   

 %% sector specific shocks
 
 rho_ss_vec = [-0.9589
-0.2024
-0.1676
-0.3515
-0.9213
-0.2232
0.97
-0.3861
-0.5976
-0.1875
0.3743
-0.2152
-0.5157
-0.0801
0.0698
];  %% autoregressive coefficient

               
 zetaZAlpha = rho_ss_vec;   %% vector of autoregressive coefficients
 
  %% NOTE: we assume that every sector has the same rho
 
             
 sigma_ss_vec = [0.9352
106.4503
86.9403
34.4718
43.6319
8.5047
6.3563
122.6769
19.8972
52.5698
11.7311
29.3013
44.7107
44.1223
115.7035
];
 
 

               
   SIGMA_SS = diag([sigma_ss_vec.^2;sigma_cs^2]);
 
 
 %% Loss minimization
 
 for j = 1:1  %% set >> 1 if want to check different initial conditions
    
     
%% Initial condition: cpi targeting

 %  ini_weights = an_vec;

%% Random initial conditions  

 rand_weights = abs(0.2*randn(N,1))+alpha_vec./sum(alpha_vec);
 
  ini_weights = rand_weights./sum(rand_weights);

%% Weight proportional to stickiness

 % ini_weights = alpha_vec./sum(alpha_vec);

%% optimal weights in previous experiment...

%   ini_weights = [0.0001
% 0.04
% 0.03
% 0.02
% 0.03
% 0.02
% 0.0001
% 0.05
% 0.08
% 0.0001
% 0.21
% 0.01
% 0.02
% 0.10
% 0.0001
% 0.25
% 0.13
% ]; 


    
%% Vasco transformation to obtain positive weights (we normalize second
%% sector so that the sector with higher weight is 1)

    
if sel == 2

ini_weights_vasco1 = log(ini_weights(1:N)./ini_weights(5));
ini_weights_vasco = [ini_weights_vasco1(1:4);ini_weights_vasco1(6:end)];

else

ini_weights_vasco = ini_weights(1);


end


    

diary('results')
  
  %% Unconstrained optimization
 


x0 = ini_weights_vasco;

size_vector = 1e-3.*ones(length(x0),1);
GMat = diag(size_vector);

 

 
 
 stop_crit_x = 1e-6; stop_crit_f = 1e-7; maxits = 1000; 

 max_funevals = 10*maxits;

 options = optimset('Display','iter','TolX',stop_crit_x,'TolFun',stop_crit_f,'MaxFunEvals',max_funevals,'MaxIter',maxits);
%,'Hessian','on');

for j = 1:3

    
 [opt_x,fval,exitflag,output] = fminsearch('Loss_fun_cs',x0,options);
   
 %x0 = opt_x; 
 
if exitflag == 1
    opt_x1 = opt_x;
    break
   
end

x1 = opt_x;

if j == 3
   
%    diary('results')
end

[fh,opt_x1,gh,H,itct,fcount,retcodeh] = csminwel('Loss_fun_cs',x1,GMat,[],1e-7,100);


x0 = opt_x1;



end

opt_weights = opt_x1;




%% display optimal weights

if sel == 2
    
opt_weights_n = [exp(opt_weights(1:4));1; exp(opt_weights(5:end))];

opt_weights_n =(opt_weights_n./sum(opt_weights_n))

else
    
opt_weights_n = opt_weights;


end


end


diary off



save results 

