
 clear all;clc

%%% PERFORMS LOSS MINIMIZATION


%global beta sigma gamma eta an_vec alpha_vec lambda_vec theta_vec N
%global beta sigma gamma eta zetaZAlpha SIGMA_SS an_vec alpha_vec lambda_vec theta_vec dimK NF N G sel W_mat
global beta sigma gamma eta zetaZAlpha SIGMA_SS an_vec alpha_vec lambda_vec theta_vec dimK NF N G sel rho_cts%D W_mat F

%global A B C
%% Model parameters


%% Preferences and technologies

 beta = .997; % discount rate  
 gamma = 1;  % elasticity of substitution inter sector
 theta = 5; % elasticity of substitution intra sector
 eta = 0.5;  % elasticity of marginal cost w.r.t. output/consumption
 sigma = 1;  % elastasticity of substitution for consumption           
 lambda = 1/0.88; %% curvature in production function          
  alpha = 1-0.103; %% homog. Calvo param
 
 
 %% OPTIONS 
 
 sel = 2;    
 
 %% set sel ==
 %% 1. core-noncore
 %% 2. multisector
 
%% CORE-NONCORE

  N = 15; % Number of sectors


%% Sector shares
  
  an_vec = [0.056
0.045
0.024
0.085
0.052
0.042
0.027
0.079
0.151
0.035
0.022
0.041
0.162
0.040
0.138
];%./100;
% Re-normalize an_vec

an_vec = an_vec./sum(an_vec);


 
alpha_vec = [0.366
0.092
0.109
0.130
0.056
0.322
0.876
0.104
0.103
0.114
0.385
0.156
0.083
0.100
0.075
];%./100;  
alpha_vec = 1-alpha_vec; 
           
 theta_vec = [5.2
5.0
4.9
4.5
5.0
4.8
4.0
4.7
4.9
5.2
3.2
5.2
7.7
6.1
6.0
];

 
lambda_vec  = 1./[0.89
0.88
0.88
0.86
0.88
0.87
0.82
0.87
0.88
0.89
0.75
0.89
0.94
0.92
0.92
];
    
    

 %% common shock

  sigma_cs = 2.3972/100; %std of common shock

  rho_cts = 0.3549;


   
   

 %% sector specific shocks
 
 rho_ss_vec = [-0.9589
-0.2024
-0.1676
-0.3515
-0.9213
-0.2232
0.97
-0.3861
-0.5976
-0.1875
0.3743
-0.2152
-0.5157
-0.0801
0.0698
];  %% autoregressive coefficient

               
 zetaZAlpha = rho_ss_vec;   %% vector of autoregressive coefficients
 
%  zetaZAlpha = rho_ss.*ones(N,1);   %% vector of autoregressive coefficients
  %% NOTE: we assume that every sector has the same rho
 
             
 sigma_ss_vec = [0.9352
106.4503
86.9403
34.4718
43.6319
8.5047
6.3563
122.6769
19.8972
52.5698
11.7311
29.3013
44.7107
44.1223
115.7035
]./100;
 
   SIGMA_SS = diag([sigma_ss_vec.^2;sigma_cs^2]);
 


%% Uploading weights and shock calibration

   %% Pce: this case is not really interesting. it is rather the benchmark
   %% to measure improvements
 
 %% CONDI weights
 
  opt_weights = [0.4%
4.6%
1.7%
4.1%
14.7%
0.3%
0.000000001%
6.1%
12.2%
2.4%
0.1%
1.4%
25.5%
3.7%
22.6%


]./100;

opt_weights = opt_weights/sum(opt_weights);

%% Computing loss
 


%% optimal weights rearranged...

ini_weights = opt_weights; 

ini_weights_cpi = an_vec;







%% core only

ini_weights_core_raw = an_vec;

ini_weights_core_raw(4:5) = zeros(2,1);
ini_weights_core_raw(7) = 0;
ini_weights_core_raw(11) = 0;  

%ini_weights_core_raw = ini_weights_core_raw+0.0001*(ones(15,1));

sum_weighs = sum(ini_weights_core_raw);
ini_weights_core = ini_weights_core_raw./sum_weighs;


%% core+food away from home

ini_weights_core1_raw = an_vec;

ini_weights_core1_raw(4) = 0;
ini_weights_core1_raw(7) = 0;
ini_weights_core1_raw(11) = 0;    

sum_weighs1 = sum(ini_weights_core1_raw);
ini_weights_core_c1 = ini_weights_core1_raw./sum_weighs1;
    
%% core+food away-autos-clothing

ini_weights_core2_raw = an_vec;

ini_weights_core2_raw(1) = 0;
ini_weights_core2_raw(4) = 0;
ini_weights_core2_raw(6) = 0;
ini_weights_core2_raw(7) = 0;
ini_weights_core2_raw(11) = 0;


sum_weighs2 = sum(ini_weights_core2_raw);
ini_weights_core_c2 = ini_weights_core2_raw./sum_weighs2;


%% Vasco transformation to obtain positive weights (we normalize second
%% sector so that the sector with higher weight is 1)


ini_weights_vasco1 = log(ini_weights(1:N)./ini_weights(9));
ini_weights_vasco = [ini_weights_vasco1(1:8);ini_weights_vasco1(10:end)];

ini_weights_vasco_cpi1 = log(ini_weights_cpi(1:N)./ini_weights_cpi(9));
ini_weights_vasco_cpi = [ini_weights_vasco_cpi1(1:8);ini_weights_vasco_cpi1(10:end)];

ini_weights_vasco_core1 = log(ini_weights_core(1:N)./ini_weights_core(9));
ini_weights_vasco_core = [ini_weights_vasco_core1(1:8);ini_weights_vasco_core1(10:end)];

ini_weights_vasco_core_c11 = log(ini_weights_core_c1(1:N)./ini_weights_core_c1(9));
ini_weights_vasco_core_c1 = [ini_weights_vasco_core_c11(1:8);ini_weights_vasco_core_c11(10:end)];

ini_weights_vasco_core_c21 = log(ini_weights_core_c2(1:N)./ini_weights_core_c2(9));
ini_weights_vasco_core_c2 = [ini_weights_vasco_core_c21(1:8);ini_weights_vasco_core_c21(10:end)];


  

 %% Loss under optimal policy

Loss_opt = Loss_fun_opt(ini_weights_vasco);


 %% Loss under suboptimal policy

Loss_sub_opt = Loss_fun_cs(ini_weights_vasco);


%% Loss under cpi

Loss_sub_cpi = Loss_fun_cs(ini_weights_vasco_cpi);

%% Loss under core

Loss_sub_core = Loss_fun_cs(ini_weights_vasco_core);



%% Loss under core+food away from home

Loss_sub_c1 = Loss_fun_cs(ini_weights_vasco_core_c1);

%% Loss under core+food away-autos-clothing

Loss_sub_c2 = Loss_fun_cs(ini_weights_vasco_core_c2);


%% Compupting inflation equivalent

eta_vec = lambda_vec.*(1+eta)-1; %% convolution of parameters...

den_vec = 1.+(theta_vec.*eta_vec); %% this is  the vector 1+theta(n)*eta in the
                               %% Phillips curve. It expresses the common
                               %% denominator of the variables'
                               %% coefficients

el_mc_vec = ((1-alpha_vec.*beta).*(1-alpha_vec))...
      ./alpha_vec; %% defines vector of the elasticity of inflation to the
                    %%% mc in each sector

pi_eq = 12*sqrt(((1-beta)./(an_vec'*(theta_vec.*den_vec./el_mc_vec))))*sqrt(Loss_sub_opt-Loss_opt);

pi_eq_cpi = 12*sqrt(((1-beta)./(an_vec'*(theta_vec.*den_vec./el_mc_vec))))*sqrt(Loss_sub_cpi-Loss_opt);

pi_eq_core = 12*sqrt(((1-beta)./(an_vec'*(theta_vec.*den_vec./el_mc_vec))))*sqrt(Loss_sub_core-Loss_opt);

pi_eq_c1 = 12*sqrt(((1-beta)./(an_vec'*(theta_vec.*den_vec./el_mc_vec))))*sqrt(Loss_sub_c1-Loss_opt);
    
pi_eq_c2 = 12*sqrt(((1-beta)./(an_vec'*(theta_vec.*den_vec./el_mc_vec))))*sqrt(Loss_sub_c2-Loss_opt);



